---
title: Using the Payment Request API
slug: Web/API/Payment_Request_API/Using_the_Payment_Request_API
tags:
  - Demos
  - Examples
  - Guide
  - Payment Request API
  - PaymentRequest
---
<div>{{DefaultAPISidebar("Payment Request API")}}{{securecontext_header}}</div>

<p>The <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> provides a browser-based method of connecting users and their preferred payment systems and platforms to merchants that they want to pay for goods and services. <span class="seoSummary">This article is a guide to making use of the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a>, with examples and suggested best practices.</span></p>

<h2 id="The_basics_of_making_a_payment">The basics of making a payment</h2>

<p>This section details the basics of using the Payment Request API to make a payment.</p>

<div class="note">
<p><strong>Note</strong>: The code snippets from this section are from our <a href="https://github.com/mdn/dom-examples/blob/master/payment-request/feature-detect-support.html">Feature detect support demo</a>.</p>
</div>

<h3 id="Creating_a_new_payment_request_object">Creating a new payment request object</h3>

<p>A payment request always starts with the creation of a new {{domxref("PaymentRequest")}} object — using the {{domxref("PaymentRequest.PaymentRequest", "PaymentRequest()")}} constructor. This takes two mandatory parameters and one option parameter:</p>

<ul>
 <li><code>methodData</code> — an object containing information concerning the payment provider, such as what payment methods are supported, etc.</li>
 <li><code>details</code> — an object containing information concerning the specific payment, such as the total payment amount, tax, shipping cost, etc.</li>
 <li><code>options</code> (optional) — an object containing addtional options related to the payment.</li>
</ul>

<p>So for example, you could create a new <code>PaymentRequest</code> instance like so:</p>

<pre class="brush: js notranslate">var request = new PaymentRequest(buildSupportedPaymentMethodData(),
                                 buildShoppingCartDetails());</pre>

<p>The functions invoked inside the constructor return the required object parameters:</p>

<pre class="brush: js notranslate">function buildSupportedPaymentMethodData() {
  // Example supported payment methods:
  return [{
    supportedMethods: 'basic-card',
    data: {
      supportedNetworks: ['visa', 'mastercard'],
      supportedTypes: ['debit', 'credit']
    }
  }];
}

function buildShoppingCartDetails() {
  // Hardcoded for demo purposes:
  return {
    id: 'order-123',
    displayItems: [
      {
        label: 'Example item',
        amount: {currency: 'USD', value: '1.00'}
      }
    ],
    total: {
      label: 'Total',
      amount: {currency: 'USD', value: '1.00'}
    }
  };
}</pre>

<h3 id="Starting_the_payment_process">Starting the payment process</h3>

<p>Once the <code>PaymentRequest</code> object has been created, you call the {{domxref("PaymentRequest.show()")}} method on it to initiate the payment request. This returns a promise that fulfills with a {{domxref("PaymentResponse")}} object if the payment is successful:</p>

<pre class="brush: js notranslate">request.show().then(function(paymentResponse) {
  // Here we would process the payment. For this demo, simulate immediate success:
  paymentResponse.complete('success')
  .then(function() {
    // For demo purposes:
    introPanel.style.display = 'none';
    successPanel.style.display = 'block';
  });
})</pre>

<p>This object provides the developer with access to details they can use to complete the logical steps required after the payment completes, such as an email address to contact the customer, a shipping address for mailing goods out to them, etc. In the code above, you'll see that we've called the {{domxref("PaymentResponse.complete()")}} method to signal that the interaction has finished — you'd use this to carry out finishing steps, like updating the user interface to tell the user the transaction is complete, etc.</p>

<h3 id="Other_useful_payment_request_methods">Other useful payment request methods</h3>

<p>There are some other useful payment request methods worth knowing about.</p>

<p>{{domxref("PaymentRequest.canMakePayment()")}} can be used to check whether the <code>PaymentRequest</code> object is capable of making a payment before you start the payment process. It returns a promise that fulfills with a boolean indicating whether it is or not, for example:</p>

<pre class="brush: js notranslate">// Dummy payment request to check whether payment can be made
new PaymentRequest(buildSupportedPaymentMethodData(),
      {total: {label: 'Stub', amount: {currency: 'USD', value: '0.01'}}})
      .canMakePayment()
      .then(function(result) {
        if(result) {
          // Real payment request
          var request = new PaymentRequest(buildSupportedPaymentMethodData(),
                                           checkoutObject);

          request.show().then(function(paymentResponse) {
            // Here we would process the payment.
            paymentResponse.complete('success')
              .then(function() {
                // Finish handling payment
            });
          })
        }
      })
</pre>

<p>{{domxref("PaymentRequest.abort()")}} can be used to abort the payment request if required.</p>

<h2 id="Detecting_availability_of_the_Payment_Request_API">Detecting availability of the Payment Request API</h2>

<p>You can effectively detect support for the Payment Request API by checking if the user's browser supports {{domxref("PaymentRequest")}}, i.e. <code>if (window.PaymentRequest)</code>.</p>

<p>In the following snippet, a merchant page performs this check, and if it returns <code>true</code> updates the checkout button to use <code>PaymentRequest</code> instead of legacy web forms.</p>

<pre class="brush: js notranslate"><code class="javascript language-javascript">const checkoutButton = document.getElementById('checkout-button');
if (window.PaymentRequest) {
  let request = new PaymentRequest(buildSupportedPaymentMethodNames(),
      buildShoppingCartDetails());
  checkoutButton.addEventListener('click', function() {
    request.show().then(function(paymentResponse) {
      // Handle successful payment
    }).catch(function(error) {
      // Handle cancelled or failed payment. For example, redirect to
      // the legacy web form checkout:
      window.location.href = '/legacy-web-form-checkout';
    });
    // Every click on the checkout button should use a new instance of
    // PaymentRequest object, because PaymentRequest.show() can be
    // called only once per instance.
    request = new PaymentRequest(buildSupportedPaymentMethodNames(),
        buildShoppingCartDetails());
  });
}
</code></pre>

<div class="note">
<p><strong>Note</strong>: See our <a href="https://mdn.github.io/dom-examples/payment-request/feature-detect-support.html">Feature detect support demo</a> for the full code.</p>
</div>

<h2 id="Checking_whether_users_can_make_payments">Checking whether users can make payments</h2>

<p>Checking whether users can make payments is always useful. Here's a couple of related techniques.</p>

<h3 id="Customizing_the_payment_button">Customizing the payment button</h3>

<p>One useful technique to employ is customizing the payment request button depending on whether users can make payments.</p>

<p>In the following snippet we do just this — depending on whether the user can make a fast payment or needs to add payment credentials first, the title of the checkout button changes between "Fast Checkout with W3C" and "Setup W3C Checkout". In both cases, the checkout button calls {{domxref("PaymentRequest.show()")}}.</p>

<pre class="brush: js notranslate"><code class="javascript language-javascript">const checkoutButton = document.getElementById('checkout-button');
checkoutButton.innerText = "Loading...";
if (window.PaymentRequest) {
  let request = new PaymentRequest(buildSupportedPaymentMethodNames(),
      buildShoppingCartDetails());
  request.canMakePayment().then(function(canMakeAFastPayment) {
    if (canMakeAFastPayment) {
      checkoutButton.innerText = "Fast Checkout with W3C";
    } else {
      checkoutButton.innerText = "Setup W3C Checkout";
    }
  }).catch(function(error) {
    // The user may have turned off the querying functionality in their
    // privacy settings. The website does not know whether they can make
    // a fast payment, so pick a generic title.
    checkoutButton.innerText = "Checkout with W3C";
  });
}
</code></pre>

<div class="note">
<p><strong>Note</strong>: See our <a href="https://mdn.github.io/dom-examples/payment-request/customize-button-can-make-payment.html">Customizing the payment button demo</a> for the full code.</p>
</div>

<h3 id="Checking_before_all_prices_are_known">Checking before all prices are known</h3>

<p>If the checkout flow needs to know whether {{domxref("PaymentRequest.canMakePayment()")}} will return <code>true</code> even before all line items and their prices are known, you can instantiate <code>PaymentRequest</code> with dummy data and pre-query <code>.canMakePayment()</code>. If you call <code>.canMakePayment()</code> multiple times, keep in mind that the first parameter to the <code>PaymentRequest</code> constructor should contain the same method names and data.</p>

<pre class="brush: js notranslate"><code class="javascript language-javascript">// The page has loaded. Should the page use PaymentRequest?
// If PaymentRequest fails, should the page fallback to manual
// web form checkout?
const supportedPaymentMethods = ...
let shouldCallPaymentRequest = true;
let fallbackToLegacyOnPaymentRequestFailure = false;
(new PaymentRequest(supportedPaymentMethods,
    {total: {label: 'Stub', amount: {currency: 'USD', value: '0.01'}}})
.canMakePayment()
.then(function(result) {
  shouldCallPaymentRequest = result;
}).catch(function(error) {
  console.log(error);
  // The user may have turned off query ability in their privacy settings.
  // Let's use PaymentRequest by default and fallback to legacy
  // web form based checkout.
  shouldCallPaymentRequest = true;
  fallbackToLegacyOnPaymentRequestFailure = true;
});

// User has clicked on the checkout button. We know
// what's in the cart, but we don't have a `Checkout` object.
function onCheckoutButtonClicked(lineItems) {
  callServerToRetrieveCheckoutDetails(lineItems);
}

// The server has constructed the `Checkout` object. Now we know
// all of the prices and shipping options.
function onServerCheckoutDetailsRetrieved(checkoutObject) {
  if (shouldCallPaymentRequest) {
    const request = new PaymentRequest(supportedPaymentMethods, checkoutObject);
    request.show().then(function(paymentResponse) {
      // Post the results to the server and call `paymeResponse.complete()`.
    }).catch(function(error) {
      console.log(error);
      if (fallbackToLegacyOnPaymentRequestFailure) {
        window.location.href = '/legacy-web-form-checkout';
      } else {
        showCheckoutErrorToUser();
      }
    });
  } else {
    window.location.href = '/legacy-web-form-checkout';
  }
}</code></pre>

<div class="note">
<p><strong>Note</strong>: See our <a href="https://mdn.github.io/dom-examples/payment-request/check-user-can-make-payment.html">Checking user can make payments before prices are known demo</a> for the full code.</p>
</div>

<h2 id="Recommending_a_payment_app_when_user_has_no_apps">Recommending a payment app when user has no apps</h2>

<p>If you select to pay with the BobPay demo payment provider on this merchant page, it tries to call <code>PaymentRequest.show()</code>, while intercepting the <code>NOTSUPPORTEDERR</code> exception. If this payment method is not supported, it redirects to the signup page for BobPay.</p>

<p>The code looks something like this:</p>

<pre class="brush: js notranslate">checkoutButton.addEventListener('click', function() {
  var request = new PaymentRequest(buildSupportedPaymentMethodData(),
    buildShoppingCartDetails());
    request.show().then(function(paymentResponse) {
    // Here we would process the payment. For this demo, simulate immediate success:
    paymentResponse.complete('success')
      .then(function() {
          // For demo purposes:
          introPanel.style.display = 'none';
          successPanel.style.display = 'block';
        });
  }).catch(function(error) {
    if (error.code == DOMException.NOT_SUPPORTED_ERR) {
      window.location.href =
        'https://bobpay.xyz/#download';
    } else {
      // Other kinds of errors; cancelled or failed payment. For demo purposes:
      introPanel.style.display = 'none';
      legacyPanel.style.display = 'block';
    }
  });
});</pre>

<div class="note">
<p><strong>Note</strong>: See our <a href="https://mdn.github.io/dom-examples/payment-request/recommend-payment-app.html">Recommending a payment app when user has no apps demo</a> for the full code.</p>
</div>

<h2 id="Showing_additional_user_interface_after_successful_payments">Showing additional user interface after successful payments</h2>

<p>If the merchant desires to collect additional information not part of the API (e.g., additional delivery instructions), the merchant can show a page with additional <code>&lt;input type="text"&gt;</code> fields after the checkout.</p>

<pre class="brush: js notranslate"><code class="javascript language-javascript">request.show()
.then(function(paymentResponse) {
    // Process payment here.
    // Close the UI:
    paymentResponse.complete('success').then(function() {
        // Request additional shipping address details.
        const additionalDetailsContainer = document.getElementById('additional-details-container');
        additionalDetailsContainer.style.display = 'block';
        window.scrollto(additionalDetailsContainer.getBoundingClientRect().x, 0);
    }).catch(function(error) {
        // Handle error.
    });
})
.catch(function(error) {
    // Handle error.
});
</code></pre>

<div class="note">
<p><strong>Note</strong>: See our <a href="https://mdn.github.io/dom-examples/payment-request/show-additional-ui-after-payment.html">Show additional user interface after successful payment demo</a> for the full code.</p>
</div>

<h2 id="Pre-authorizing_transactions">Pre-authorizing transactions</h2>

<p>Some use cases (e.g., paying for fuel at a service station) involve pre-authorization of payment. One way to do this is through a Payment Handler (see the <a href="https://w3c.github.io/payment-handler/">Payment Handler API</a>). At time of writing, that specification includes a <code>CanMakePayment</code> event that a Payment Handler could make use of to return authorization status.</p>

<p>The merchant code would look like this:</p>

<pre class="brush: js notranslate"><code class="javascript language-javascript">let paymentRequest = new PaymentRequest(
    [{supportedMethods: 'https://example.com/preauth'}], ...);
// Send `CanMakePayment` event to the payment handler.
paymentRequest.canMakePayment()
    .then(function(res) {
      if (res) {
       // The payment handler has pre-authorized a transaction
       // with some static amount, e.g., USD $1.00.
      } else {
        // Pre-authorization failed or payment handler not installed.
      }
    })
    .catch(function(ex1) {
      // Unexpected error occurred.
    });
</code></pre>

<p>The payment handler would include the following code:</p>

<pre class="brush: js notranslate"><code class="javascript language-javascript">self.addEventListener('canmakepayment', function(evt) {
  // Pre-authorize here.
  let preAuthSuccess = ...;
  evt.respondWith(preAuthSuccess);
});
</code></pre>

<p>This payment handler would need to live in a service worker at <code>https://example.com/preauth</code> scope.</p>

<div class="note">
<p><strong>Note</strong>: See our <a href="https://mdn.github.io/dom-examples/payment-request/pre-authorize-transaction.html">Pre-authorizing transactions demo</a> for the full code.</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://googlechrome.github.io/samples/paymentrequest/">Google PaymentRequest Samples</a></li>
 <li><a href="https://g.co/PaymentRequestCodeLab">Google PaymentRequest codelab</a></li>
 <li>Ecommerce website demo and source code <a href="https://github.com/pjbazin/wpwg-demo">VeggieShop</a></li>
 <li>Web Payment App demo and source code <a href="https://github.com/pjbazin/wpwg-demo/tree/master/WhiteCollar">WhiteCollar</a></li>
</ul>
